--- chan_sip.c.orig	2005-07-22 20:40:03.703150912 -0600
+++ chan_sip.c	2005-07-23 04:17:06.834201312 -0600
@@ -8157,15 +8157,26 @@
 		return NULL;
 	}
 
-	p = chan->tech_pvt;
+	/* make sure the private structure is not destroyed while we are trying to access it */
+	ast_mutex_lock(&iflock);
+	if (chan->tech_pvt) {
+		p = chan->tech_pvt;
+	} else {
+		ast_log(LOG_WARNING, "SIP channel private structures no longer exist.\n");
+		ast_mutex_unlock(&iflock);
+		ast_mutex_unlock(&chan->lock);
+		return NULL;
+	}
 	content = get_header(&p->initreq, data);
 
 	if (ast_strlen_zero(content)) {
+		ast_mutex_unlock(&iflock);
 		ast_mutex_unlock(&chan->lock);
 		return NULL;
 	}
 
 	ast_copy_string(buf, content, len);
+	ast_mutex_unlock(&iflock);
 	ast_mutex_unlock(&chan->lock);
 
 	return buf;
